#!/usr/bin/env bash
#
# orthologer - Pipeline for deducing orthology from fasta files.
# Copyright (C) 2005-2023 E. Zdobnov lab: F. Tegenfeldt
# <fredrik.tegenfeldt@unige.ch> based on code by E. Kriventseva
#
# This file is part of orthologer.
#
# orthologer is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# orthologer is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with orthologer.  If not, see <http://www.gnu.org/licenses/>.
#
#
# Run given masker algorithm.
# The command line format is
#   run_masker.sh <todo>
#
#--- check if environment is ok -----------------
[[ "${LOADED_COMMON_ORTHODB_SH+1}" == "" ]] && echo "ERROR $0 : main config has not been loaded" 1>&2 && exit 255
#------------------------------------------------

[[ $# -gt 0 ]] || fatal_msg "usage: $0 <label>"

[[ -x "$MASKER_SCRIPT" ]] || fatal_msg "masker not found - script : $MASKER_SCRIPT"

input="$1"
inparr=( $(tokenize ";" $input) )

nok=0
nerr=0
ec=0

tmpout=""
tmp_make tmpout "masker"

# loop over set of arguments separated by ';'
for args in ${inparr[@]}; do
    echo
    print_separator
    info_msg "Starting MASKER job <$args>"
    print_separator
    echo

    fasta="$DIR_PROJECT_SEQUENCES/${args}.$EXT_FASTA"
    outfile=$(set_extension "$fasta" $EXT_FASTA_MASKED)

    # check file existance
    check_file "$0" "$fasta" || exit 255

    # run masker script in subshell
    (tmp_setup_trap && source $MASKER_SCRIPT "$fasta" "$tmpout")
    ec=$?
    
    if [[ $ec -eq 0 ]]; then
        cp -f "$tmpout" "$outfile"
        ec=$?
    fi

    if [[ $ec -eq 0 ]]; then
        nok=$((nok+1))
    else
        nerr=$((nerr+1))
    fi
    echo
    print_separator
    info_msg "Done MASKER job <$args>"
    print_separator
done
echo
[[ $nerr -eq 0 ]] || { info_msg "Completed $nok succesfully and $nerr with errors"; exit 255; }
